
ETreePainter* treepainter = NULL;
TTree *etree = NULL;
TTree *stree = NULL;
TChain *chain = NULL;
Bool_t SAVED = false;  // to know if stree has been already saved

//
// WARNING : 
//	- GammaA   :  changer ETreePainter (X1 pb), et changer nom _back_ en _air_ (ckov scattered)
//

//______________________________________________________________________________
void MakeStree() {
   
    chainlistoffiles();
}


//______________________________________________________________________________
void gettree() {
    etree = (TTree*)gDirectory->Get("etree");
    if ( etree ) {
        printf("etree with %d events found.", (Int_t)etree->GetEntries());
	if (treepainter)
            delete treepainter;
	treepainter = new ETreePainter( etree );
    }
    
    stree = (TTree*)gDirectory->Get("stree"); 
    if (!stree) {
      Warning("gettree()","Fail to generate stree");
      return;
    }
    savesimpletree();
}

//______________________________________________________________________________
void getstree() {
    stree = (TTree*)gDirectory->Get("stree");
    if ( stree ) {
        printf("stree with %d events found.", (Int_t)stree->GetEntries());
	if (treepainter)
            delete treepainter;
	treepainter = new ETreePainter( stree );
	SAVED = true;
    }
    else Warning("getstree()","stree not found");
}

//______________________________________________________________________________
Bool_t checktree( Option_t *opt = "default" ) {
    TString option(opt);
    Bool_t rtn = true;
    if ((opt == "etree") && !etree ) {
        Warning("I do not find etree");
	rtn = false;
	//help();
    }
    else if((opt == "stree") && !stree ) {
        Warning("I do not find stree");
	rtn = false;
	//help();
    
    }
    else if((opt == "chain") && !chain ) {
        Warning("I do not find chain");
	rtn = false;
	//help();
    }
    else if((opt == "default")&&!etree&&!chain&&!stree) {
        Warning("checktree()","NO TREE FOUND (no chain, etree or stree)");
	rtn = false;
	//help();
    }
    
    return rtn;
}

//______________________________________________________________________________
void getchain() {
  //    chain = (TChain*)gDirectory->Get("etree");
    if (chain) {
        printf("chain etree with %d events found.\n", (Int_t)chain->GetEntries());
	if (treepainter)
           delete treepainter;
	treepainter = new ETreePainter( chain );
    }
    
    stree = (TTree*)gDirectory->Get("stree"); 
    if (!stree) {
      Warning("getchain()","Fail to generate stree");
      return;
    }
    savesimpletree();
}

//______________________________________________________________________________
void chainfiles() {

    chain = new TChain("etree");
    TFile *f = 0;
    delete f;
    TGFileInfo* info = new TGFileInfo();
    while (true) {
        TGFileDialog* filedialog = new TGFileDialog(gClient->GetRoot(), 0, kFDOpen, info);
        if ( info->fFilename ) {
           f = new TFile( info->fFilename );
           if ( f && !f->IsZombie() ) {
              chain->Add( info->fFilename );
              printf("%s successfully opened number of trees %d, number of events %d \n", 
                     info->fFilename,chain->GetNtrees(),(Int_t)chain->GetEntries());
	   }
           else 
              printf("Unable to open %s",info->fFilename);
        }
        else break;
    }
    //    chain->Merge("all.root");
    //    gettree();
    getchain();
}

//______________________________________________________________________________
void chaingenfiles() {

    chain = new TChain("etree");
    TFile *f = 0;
    delete f;
    TGFileInfo* info = new TGFileInfo();
    while (true) {
        TGFileDialog* filedialog = new TGFileDialog(gClient->GetRoot(), 0, kFDOpen, info);
        if ( info->fFilename ) {
              chain->Add( info->fFilename );
              printf("%s successfully opened number of trees %d, number of events %d \n", 
                     info->fFilename,chain->GetNtrees(),(Int_t)chain->GetEntries());
        }
        else break;
    }
    getchain();
}

//DELETE
/*
//______________________________________________________________________________
void chainlistoffiles2() {

    stree = 0;
    SAVED = false;
    chain = new TChain("etree");
    TFile* f=0;
    delete f;
    char FileName[80];
    Int_t nbf=0;

    FILE* lof;
    lof =  fopen("loadZeta_C","r"); 
    while (fgets(FileName,80,lof)) {
      nbf++;  
      Int_t s=strlen(FileName);
      if(FileName[s-1]='\n') FileName[s-1]=0;
      printf("file Nb %d : %s \n",nbf,FileName);
      f = new TFile( FileName );
      if ( f && !f->IsZombie() ) {
          chain->Add( FileName );
          printf("%s successfully opened number of trees %d, number of events %d \n", 
             FileName,chain->GetNtrees(),(Int_t)chain->GetEntries());
      }
      else printf("Unable to open %s",FileName);
    }
    fclose(lof);
    
    getchain();
}
*/

//______________________________________________________________________________
void chainlistoffiles() {

    stree = 0;
    SAVED = false;
    chain = new TChain("etree");
    TFile* f=0;
    delete f;
    char FileName[80];
    Int_t nbf=0;
    TGFileInfo* info = new TGFileInfo();

    TGFileDialog* filedialog = new TGFileDialog(gClient->GetRoot(), 0, kFDOpen, info);
        if ( info->fFilename ) {  
	    FILE* lof;
            lof =  fopen(info->fFilename,"r"); 
	    while (fgets(FileName,80,lof)) {
	      nbf++;  
              Int_t s=strlen(FileName);
              if(FileName[s-1]='\n') FileName[s-1]=0;
              printf("file Nb %d : %s \n",nbf,FileName);
              f = new TFile( FileName );
              if ( f && !f->IsZombie() ) {
                  chain->Add( FileName );
                  printf("%s successfully opened number of trees %d, number of events %d \n", 
                     FileName,chain->GetNtrees(),(Int_t)chain->GetEntries());
              }
              else printf("Unable to open %s",FileName);
	    }
	    fclose(lof);
        }
        else break;
    
    getchain();
}

//______________________________________________________________________________
void simpletreeviewer() {    
    stree=(TTree*)gDirectory->Get("stree"); 
    if (!stree) {
	Warning("simpletreeviewer()","No stree found");
        printf("I do not find simple results tree.");
        return;
    }
    stree->StartViewer();
}

//______________________________________________________________________________
void savesimpletree() {
    if (!stree) {
      printf("Cannot save stree, it has not been generated");
      return;
    }

    TFile *f = 0;
    delete f;
    Bool_t wantosave = true;
    
    TGFileInfo* info = new TGFileInfo();
    while ( info->fFilename == 0 || !f || f->IsZombie() ) {
        TGFileDialog* filedialog = new TGFileDialog(gClient->GetRoot(), 0, kFDSave, info);
        if ( info->fFilename && !SAVED ) f = new TFile( info->fFilename,"create");
	else {wantosave = false; break;}
    }
    if(wantosave && !SAVED) stree->Write();
    else if(SAVED) Info("savesimpletree()","stree is already saved");
    SAVED = true;
   
    stree->Write();
    f->Close();
}

