// $Id: MakePixelMapPhotonFile.C,v 1.2 2005/04/24 14:16:23 thea Exp $
// Author: A.Thea   2005/04/19

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: MakePixelMapPhotonFile                                               *
 *  Package: Macros                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

//______________________________________________________________________________
void MakePixelMapPhotonFile( const char* name=0 ) {
    //
    // Builds the pixlemap photons file according the current config
    //
    
    if ( name ) {
        TString key = "PixelMapBuilder";
        TString value = key+".fRootFileName = "+name;
        Config::Get()->AddUserDefinition(std::string(key),std::string(value));
    }

    PixelMapBuilder builder;
    builder.OpenRoot();
    builder.Go();
    builder.CloseRoot();
}

//______________________________________________________________________________
void MakeUserPixelMapPhotonFile( const char* name=0, const char* usercfg=0 ) {
    //
    // Builds the pixlemap photons file according the user config
    //
    
    if ( usercfg ) {
        cout << "User config file " << usercfg << " loaded" << endl;
        Config::Get()->LoadUserConfig(usercfg);
    }

    MakePixelMapPhotonFile( name );
}
