// ESAF : Euso Simulation and Analysis Framework
// $Id: CloudsData.hh,v 1.3 2004/09/13 21:46:07 thea Exp $
// Sylvain Moreggia created May, 19 2004

#ifndef __CLOUDSDATA_HH_
#define __CLOUDSDATA_HH_

#include "euso.hh"

/*******************************************************************************
 *
 * CloudsData : class description
 *
 * Interface for clouds data storage
 * Each Clouds type holds its associated CloudsData
 * Each clouds description has its associated propagator (in RadiativeTransfer module)
 *
 ******************************************************************************/

class EarthVector;


class CloudsData {
public:
    // ctor
    CloudsData();

    // dtor
    virtual ~CloudsData();
    
    // Returns true if is in clouds
    virtual Bool_t IsInClouds(const EarthVector&) const = 0;
    

protected:

    ClassDef(CloudsData,0)
};

#endif  /* __CLOUDSDATA_HH_ */

