// ESAF : Euso Simulation and Analysis Framework
// $Id: BaseDialogFactory.hh,v 1.5 2005/10/18 23:17:30 thea Exp $
// Marco Pallavicini created Oct,  3 2002
// Factory class to create all TGFrame objects
// (dialog window for configuration)
// It is used by class EsafConfigurable to return the right object for each class
// This is just an abstract interface
// The real factory is in package/gui
//
#ifndef __BASEDIALOGFACTORY_HH_
#define __BASEDIALOGFACTORY_HH_

#include "euso.hh"
#include <string>

using namespace std;

class TGTransientFrame;
class SimuApplication;
class TGWindow;
class TGMainFrame;

class BaseDialogFactory {
public:
    BaseDialogFactory();
    virtual ~BaseDialogFactory();

    virtual TGTransientFrame* BuildFrame( const string& name, 
		    SimuApplication*, TGWindow*, TGMainFrame* ) const = 0;

private:
    ClassDef(BaseDialogFactory,0)
};

#endif  /* __BASEDIALOGFACTORY_HH_ */

