// ESAF : Euso Simulation and Analysis Framework
// $Id: EDetectorHistoPainter.hh,v 1.2 2005/11/04 00:17:00 thea Exp $
//  created May, 27 2004

#ifndef __EDETECTORHISTOPAINTER_HH__
#define __EDETECTORHISTOPAINTER_HH__

#include "TObject.h"
#include "TSeqCollection.h"
#include "TPolyLine.h"
#include "TTimer.h"
#include "TVector3.h"
#include "TText.h"
#include <map>
#include <vector>

class EDetector;
class ERunParameters;
class TCanvas;
class TH1F;

class EDetectorHistoPainter : public TObject {
public:
    EDetectorHistoPainter();
    EDetectorHistoPainter(EDetector*, ERunParameters*);

    virtual ~EDetectorHistoPainter();
    virtual void Clear(Option_t* ="");

    void Build();
    TSeqCollection* GetListOfHistos() { return fHistos; }

    inline void SetDetector(EDetector *det) { fDetector = det; }
    inline void SetRunPars(ERunParameters *rp) { fRunPars = rp; }

    void DoGtuPhotonsHisto(TVirtualPad* = 0);
    void DoGtuPhotonsHisto2(TVirtualPad* = 0);
    void DoPhiCosThetaHisto(TVirtualPad*  = 0);
    void DoXYHisto(TVirtualPad* = 0);
    void DoWavelengthXYHisto(TVirtualPad* = 0);

    TH1F *GetGtuHisto(const char *name, const char *title);

    ClassDef(EDetectorHistoPainter,0)
private:
    Int_t fNumGtus;
    Float_t fFirstGtu;
    Float_t fLastGtu;
    Float_t fGtuLength;
    
    TSeqCollection *fHistos;
    EDetector *fDetector;
    ERunParameters *fRunPars;


};

#endif  /* __EDETECTORHISTOPAINTER_HH__ */

