#ifndef __EDETECTORPHOTONSPAINTER_HH__
#define __EDETECTORPHOTONSPAINTER_HH__

#include "EDetector.hh"
#include "TPolyMarker3D.h"

#include <TBuffer3D.h>

#include <map>

class EDetectorPhotonsPainter : public TObject {
public:

    EDetectorPhotonsPainter( EDetector* );

    virtual ~EDetectorPhotonsPainter();

    virtual void Draw( Option_t* ="" );
    virtual void Paint( Option_t* ="" );

    void BuildPoints();
private:

    EDetector *fDetector;
    Double_t fXmin, fXmax, fYmin, fYmax, fZmin, fZmax;

    Int_t fMarkerStyle;
    Int_t fMarkerSize;

    std::map< Int_t, TPolyMarker3D* > fPoints;

    TPolyMarker3D *fDetPlayer;

    ClassDef(EDetectorPhotonsPainter,0)

};

#endif  /* __EDETECTORPHOTONSPAINTER_HH_ */
