#ifndef __EOPTICSPHOTONSPAINTER_HH__
#define __EOPTICSPHOTONSPAINTER_HH__

#include "EDetector.hh"
#include "TPolyMarker3D.h"

#include <TBuffer3D.h>

#include <map>

class EOpticsPhotonsPainter : public TObject {
public:

    EOpticsPhotonsPainter( EDetector* );

    virtual ~EOpticsPhotonsPainter();

    virtual void Draw( Option_t* ="" );
    virtual void Paint( Option_t* ="" );

    void BuildPoints();
private:

    EDetector *fDetector;
    Double_t fXmin, fXmax, fYmin, fYmax, fZmin, fZmax;

    Int_t fMarkerStyle;
    Int_t fMarkerSize;

    std::map< Int_t, TPolyMarker3D* > fPoints;

    TPolyMarker3D *fDetPlayer;

    ClassDef(EOpticsPhotonsPainter,0)

};

#endif  /* __EOPTICSPHOTONSPAINTER_HH_ */
