// ESAF : Euso Simulation and Analysis Framework
// Reconstruction module factory
// $Id: ModuleFactory.hh,v 1.5 2006/03/25 11:36:07 thea Exp $
// Marco Pallavicini created Oct, 16 2003

#ifndef __MODULEFACTORY_HH_
#define __MODULEFACTORY_HH_

#include "euso.hh"
#include <string>
#include <vector>
#include "EsafMsgSource.hh"

class RecoModule;
class InputModule;

class ModuleFactory : public EsafMsgSource {
public:
    // ctor
    ModuleFactory(const string&);

    // dtor
    virtual ~ModuleFactory();

    // get input module
    inline InputModule *GetInputModule() { return fInputModule;}

    // get modules: NULL when all modules are done
    RecoModule *GetModule();

private:
    // physically build the modules
    void MakeModule(const string& mName);
    void MakeInputModule(const string& mName);
    void MakeSequence(const string& mName);

    // modules and sequences
    vector<RecoModule*> fModules;

    // current module counter used in Get()
    size_t fCurrent;

    // input module
    InputModule *fInputModule;
    ClassDef(ModuleFactory,0)
};

#endif  /* MODULEFACTORY_HH_ */

