// ESAF : Euso Simulation and Analysis Framework
// Reconstruction test module
// $Id: TestRecoModule.hh,v 1.8 2006/03/28 09:13:43 thea Exp $
// Marco Pallavicini created Oct, 16 2003

#ifndef __TESTRECOMODULE_HH_
#define __TESTRECOMODULE_HH_

#include "euso.hh"
#include "RecoModule.hh"

class RecoRootEvent;

class TestRecoModule : public RecoModule {
public:
    // ctor 
    TestRecoModule(const string&);

    // dtor
    virtual ~TestRecoModule();
    
    // Init method: called at the beginning of a run
    virtual Bool_t Init();

    // called before each event process
    virtual Bool_t PreProcess();

    // event processing
    virtual Bool_t Process( RecoEvent* );

    // called after processing an event
    virtual Bool_t PostProcess();

    // save root output
    virtual Bool_t SaveRootData( RecoRootEvent* );

    // called at the end of each run
    virtual Bool_t Done();

    // user memory clean
    virtual void UserMemoryClean();

    // tmp memoty clean
    virtual void TmpMemoryClean();

    EsafConfigClass(Reco,TestRecoModule)

private:
    string fName;
    vector<Int_t> fTmpVector;

    ClassDef(TestRecoModule,0)
};

#endif  /* __EUSORECOMODULE_HH_ */

