// ESAF : Euso Simulation and Analysis Framework
// $Id: TestInputModule.hh,v 1.5 2004/09/15 13:48:06 naumov Exp $
// Marco Pallavicini created Oct, 16 2003

#ifndef __TESTINPUTMODULE_HH_
#define __TESTINPUTMODULE_HH_

#include "euso.hh"
#include "InputModule.hh"
class RecoRootEvent;

class TestInputModule : public InputModule {
public:
    // ctor
    TestInputModule(const string&);

    // dtor
    virtual ~TestInputModule();

    // returns one event until event source is empty
    virtual RecoEvent* GetEvent();
    
    // delete last returned event
    virtual void DestroyEvent();
    
    // init data source
    virtual Bool_t Init();

    // close data source
    virtual Bool_t Done();
    
    // save root output
    virtual Bool_t SaveRootData( RecoRootEvent* ) {return kTRUE;}

private:
    Int_t fCounter;
    ClassDef(TestInputModule,0)
};

#endif  /* __TESTINPUTMODULE_HH_ */

