// ESAF : Euso Simulation and Analysis Framework
// $Id: AutomatedClustering.hh,v 1.3 2004/09/14 12:40:20 naumov Exp $
// R. Pesce created Mar,  4 2004

#ifndef __AUTOMATEDCLUSTERING_HH_
#define __AUTOMATEDCLUSTERING_HH_

#include <vector>
#include "euso.hh"
#include "BaseClusteringModule.hh"


class AutomatedClustering : public BaseClusteringModule {

public:
    // ctor with given values
    AutomatedClustering( RecoEvent*, Int_t, Double_t, Int_t, Bool_t );

    // ctor with natural values
    AutomatedClustering( RecoEvent*, Int_t, Int_t, Bool_t );

    // dtor
    virtual ~AutomatedClustering();

    void Clustering();

    // getters
    inline vector<EusoCluster*> GetClusters() { return fClusters; }
    inline const Double_t GetDistanceThreshold() { return fThreshold; }
    inline const Int_t GetSignificanceLevel() { return fSignificanceLevel; }
    inline const Int_t GetNumHitsMinimum() { return fNumHitsMinimum; }

private:
    Bool_t gDoFit;
    
    // methods for clustering
    void CalculateDensity();
    void WriteCluster();
    
    void FitCluster( EusoCluster *clu );
    ClassDef(AutomatedClustering,0)
};

#endif  /* __AUTOMATEDCLUSTERING_HH_ */

