// $Id: RecoShowerStep.hh,v 1.3 2005/10/31 19:40:03 naumov Exp $
// Author: Dmitry.Naumov   2005/10/11

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoShowerStep                                                           *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __RECOSHOWERSTEP_HH__
#define __RECOSHOWERSTEP_HH__

#include "euso.hh"
#include "EarthVector.hh"
class TH1F;


////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// RecoShowerStep                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class RecoShowerStep {

public:
    RecoShowerStep();
    virtual ~RecoShowerStep();
    inline Float_t       GetEusoTime()    const {return fEusoTime;}
    inline EarthVector   GetPos()         const {return fPos;}
    inline EarthVector   GetDir()         const {return fDir;}
    inline Float_t       GetFluoYield()   const {return fFluoYield;}
    inline Float_t       GetAttenuation() const {return fAttenuation;}
    inline Float_t       GetNe()          const {return fNe;}
    inline Float_t       GetFlux()        const {return fFlux;}
    inline Float_t       GetLength()      const {return fLength;}
    inline Float_t       GetX()           const {return fX;}
    inline TH1F*         GetSpectrum()    const {return fSpectrum;}

private:

    Float_t        fEusoTime;
    EarthVector    fPos;
    EarthVector    fDir;
    Float_t        fFluoYield;
    Float_t        fAttenuation;
    Float_t        fNe; 
    Float_t        fFlux;
    Float_t        fLength;
    Float_t        fX;
    TH1F          *fSpectrum;
    ClassDef(RecoShowerStep,0)
    friend class RecoShowerTrack;
};

#endif  /* __RECOSHOWERSTEP_HH__ */

