// ESAF : Euso Simulation and Analysis Framework
// $Id: LeastSquaresFit.hh,v 1.3 2004/09/14 12:39:03 naumov Exp $
// R. Pesce created May, 10 2004

#ifndef __LEASTSQUARESFIT_HH_
#define __LEASTSQUARESFIT_HH_

#include "euso.hh"
#include <vector>

class LeastSquaresFit {
public:
    // ctor
    LeastSquaresFit(Int_t, vector<Double_t>, vector<Double_t>, vector<Double_t> );

    // dtor
    virtual ~LeastSquaresFit();

    //getters
    inline Double_t GetSlope() { return fSlope; }
    inline Double_t GetOffset() { return fOffset; }
    inline Double_t GetSigmaSlope() { return fSigmaSlope; }
    inline Double_t GetSigmaOffset() { return fSigmaOffset; }
    inline Double_t GetChiSquare() { return fChiSquare; }
    inline Int_t GetNumPoints() { return fNumPoints; }

private:
    Int_t fNumPoints;
    Double_t fSlope;
    Double_t fOffset;
    Double_t fSigmaSlope;
    Double_t fSigmaOffset;
    Double_t fChiSquare;
    vector<Double_t> fPointsX;
    vector<Double_t> fPointsY;
    vector<Double_t> fErr;

    void Do();
    ClassDef(LeastSquaresFit,0)
};

#endif  /* __LEASTSQUARESFIT_HH_ */

