// $Id: RecoHmaxForProton.hh,v 1.4 2005/01/05 13:08:19 pesce Exp $
// Author: R.Pesce   2005/01/04

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: RecoHmaxForProton                                                    *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

#ifndef __RECOHMAXFORPROTON_HH__
#define __RECOHMAXFORPROTON_HH__

#include "TObject.h"

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// RecoHmaxForProton                                                                 //
//                                                                            //  
// <brief class description>                                                  //  
//                                                                            //  
////////////////////////////////////////////////////////////////////////////////

class RecoHmaxForProton : public TObject {
public:
    RecoHmaxForProton();
    //ctor

    RecoHmaxForProton( const RecoHmaxForProton& );
    //copy ctor
    
    virtual ~RecoHmaxForProton();
    //dtor

    virtual void Copy( TObject& ) const;
    //copy to a new obj

    void Clear();
    //clear method

    //setters
    inline void SetQuality(Double_t t)   {fQuality = t;}
    inline void SetHmax(Double_t t)      {fHmax = t;}
    inline void SetErrorHmax(Double_t t) {fErrorHmax = t;}
    
    //getters
    inline Double_t GetQuality()   const {return fQuality;}
    inline Double_t GetHmax()      const {return fHmax;}
    inline Double_t GetErrorHmax() const {return fErrorHmax;}

private:
    Double_t fQuality;               // reconstruction quality variable defined by the the module responsible
    Double_t fHmax;
    Double_t fErrorHmax;

    ClassDef(RecoHmaxForProton,1)
};

#endif  /* __RECOHMAXFORPROTON_HH__ */

