// $Id: Baffle.cc,v 1.11 2005/04/08 17:40:24 thea Exp $
// Author: A.Thea   Oct, 10 2003

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: Baffle                                                               *
 *  Package: Optics                                                          *
 *  Coordinator: Alessandro.Thea                                             *
 *                                                                           *
 *****************************************************************************/

#include "Baffle.hh"

ClassImp(Baffle)
ClassImp(TestBaffle)

//______________________________________________________________________________
Baffle::Baffle(): fRTop(0) {
    //
    // Constructor
    //
}

//______________________________________________________________________________
Baffle::~Baffle() {
    //
    // Destructor
    //
}

//______________________________________________________________________________
//Double_t Baffle::IntersectCone(Photon* p, Double_t rUp, Double_t rDown,
//                                          Double_t zUp, Double_t zDown){
//    return -1;
//
//}

//______________________________________________________________________________
//Double_t Baffle::IntersectCone(Photon* p) {
//    return IntersectCone(p, fRTop, fR, fPos[Z]+fDZup, fPos[Z]-fDZdown);
//}

//______________________________________________________________________________
TestBaffle::TestBaffle(): Baffle() {
    // 
    // Constructor
    //
    fR      = fRTop=Conf()->GetNum("TestBaffle.fR");
    fDZup   = 0;
    fDZdown = Conf()->GetNum("TestBaffle.DZdown");
    fPos=EVector(0,0,Conf()->GetNum("TestBaffle.fPos.Z"));
}

//______________________________________________________________________________
TestBaffle::~TestBaffle() {
    //
    // Destructor
    //
}

//______________________________________________________________________________
Photon* TestBaffle::Transport(Photon *p) const {
    Double_t DL;
    if ( (DL=CylinderIntersection(p)) < 0 ) return 0;
    p->pos+=p->dir.Unit()*DL;
    return 0;
}
