// $Id: EEventGeoFiller.cc,v 1.1 2005/11/14 22:44:15 thea Exp $
// Author: Alessandro Thea   2005/11/14

/*****************************************************************************
 * ESAF: Euso Simulation and Analysis Framework                              *
 *                                                                           *
 *  Id: EEventGeoFiller                                                      *
 *  Package: <packagename>                                                   *
 *  Coordinator: <coordinator>                                               *
 *                                                                           *
 *****************************************************************************/

//_____________________________________________________________________________
//
// EEventGeoFiller
//
// <extensive class description>
//
//   Config file parameters
//   ======================
//
//   <parameter name>: <parameter description>
//   -Valid options: <available options>
//

#include "EEventGeoFiller.hh"
#include "EGeometry.hh"
#include "DetectorGeometry.hh"

#include <iostream>

ClassImp(EEventGeoFiller)

//_____________________________________________________________________________
EEventGeoFiller::EEventGeoFiller( DetectorGeometry* geo ) : EFiller("EGeometry") {
    //
    // Constructor
    //

    fGeo = geo;
}

//_____________________________________________________________________________
EEventGeoFiller::~EEventGeoFiller() {
    //
    // Destructor
    //
}

//______________________________________________________________________________
void EEventGeoFiller::Fill( EFillable* f ) {
    //
    // Event filler
    //

    EGeometry* geo = dynamic_cast<EGeometry*>(f);
    
    geo->SetPos(fGeo->GetPos());
    geo->SetFoV(fGeo->GetFoV());
    geo->SetRadius(fGeo->GetRadius());
    geo->SetRotation(*(fGeo->GetToGlobal()));

}

