      SUBROUTINE LWTRANS_V2(INIT,USR_H1,USR_H2,USR_ANGLE)
c**********************************************************************
c     Subroutine to calcul the radiative transfert throw the atmosphere
c     Based on the LOWTRAN7 program
c
c     Input parameters :
c     ------------------
c     INIT :  flag for initialisation of lowtran
C             0 initialisation of atmosphere's parameters and conditions 
c                 ( defined in the lowtran.input file )
c             1 initialisation of geometrical conditions only when
c               atmosphere's parameters have already been defined 
c
c     USR_H1, USR_H2 : altitude of the 2 points in km
c          USR_ANGLE : angle theta compare to Nadir (0=vertical)
c                        origine on ground at Nadir (EUSO = 0.,0.,400.)
c
c     Output parameters :
c     -------------------
c     compare to LWTRANS, all the ouputs are available via the
c     common block "tuple" 
c
c     Author : Anne Stutz
c     Last revised by Corinne Berat, April 2004
c
c***********************************************************************
#include "lwtrn7.common"
#include "userlun.common"
#include "tuple.common"

      INTEGER INIT
      REAL USR_H1,USR_H2,USR_ANGLE
      CHARACTER*10 OUTFILE,SAVEFILE
      CHARACTER*100 STR
      CHARACTER*25 path/'config/RadiativeTransfer/'/
      CHARACTER*19 dummy      
      IFILE  = 8
      ITAPE5 = 9
      IPRNT  = 10
      IFILE2 = 18
      
c     Atmosphere Model Initialisation
      IF(INIT.EQ.0) THEN
         NEVT=1
         ILAMBDA=0
c*******************************************************************
c     creation of the TAPE5 init file for lwtrn7

         OPEN(66,FILE=path//'LowtranFiles.dat')
         READ(66,66) dummy, TAPE5
         READ(66,66) dummy, TAPE6
         READ(66,66) dummy, TAPE7
         READ(66,66) dummy, TAPE8
         CLOSE(66)
 66      FORMAT(A,' ',A)
         CALL INITCARD3_V2(0.,0.,0.)
         CALL LWTRN7SUB
      ENDIF   
         
c     Calcul the atmospheric transmission from xpos,ypos,zpos to EUSO 
      IF(INIT.EQ.1) THEN
         NEVT = NEVT+1
         ILAMBDA=0
         CALL INITCARD3_V2(USR_H1,USR_H2,USR_ANGLE)
         CALL LWTRN7SUB
      ENDIF
c
      RETURN
      END


         









