// ESAF : Euso Simulation and Analysis Framework
// $Id: FileShowerGenerator.hh,v 1.6 2005/01/24 09:23:57 moreggia Exp $
// Alessandro Thea created Nov, 23 2003

#ifndef __FILESHOWERGENERATOR_HH_
#define __FILESHOWERGENERATOR_HH_

#include "euso.hh"
#include "EventGenerator.hh"

class PhysicsData;
class MCTruth;
class ShowerTrack;

class FileShowerGenerator : public EventGenerator {
public:
    // ctor
    FileShowerGenerator();

    // dtor
    virtual ~FileShowerGenerator();

    // get a new event
    virtual PhysicsData *Get();

    // get pointer to MonteCarlo Truth
    virtual MCTruth *GetTruth();
    
    // get ready for next event
    virtual void Reset() {}  //FIXME : to be implemented

    EsafConfigClass(Generators, FileShowerGenerator)

private:

    ShowerTrack *fTrack;
    MCTruth *fTruth;

    ClassDef(FileShowerGenerator,0)
};

#endif  /* __FILESHOWERGENERATOR_HH_ */

