// ESAF : Euso Simulation and Analysis Framework
// $Id: NoEventGenerator.hh,v 1.5 2006/02/23 10:55:38 moreggia Exp $
//  created Nov, 25 2003

#ifndef __NOEVENTGENERATOR_HH_
#define __NOEVENTGENERATOR_HH_

#include "euso.hh"
#include "EventGenerator.hh"
#include <string>

class EmptyData;
class MCTruth;

class NoEventGenerator : public EventGenerator {
public:
    // ctor
    NoEventGenerator();

    // dtor
    virtual ~NoEventGenerator();

    // get a new event
    virtual PhysicsData *Get();

    // get pointer to MonteCarlo Truth
    virtual MCTruth *GetTruth();
    
    //get ready for next event
    virtual void Reset() {}  //FIXME : to be implemented


private:
    EmptyData* fEmptyData;
    MCTruth *fTruth;                  // usefull to store atmosphere parameters

    ClassDef(NoEventGenerator,0)
};

#endif  /* __NOEVENTGENERATOR_HH_ */

