// ESAF : Euso Simulation and Analysis Framework
// $Id: NoEventGenerator.cc,v 1.4 2006/02/23 10:55:38 moreggia Exp $
//  created Nov, 25 2003

#include "NoEventGenerator.hh"
#include "EmptyData.hh"
#include "PhysicsData.hh"
#include "MCTruth.hh"

ClassImp(NoEventGenerator)

//______________________________________________________________________________
NoEventGenerator::NoEventGenerator(): EventGenerator("noevent") {
    //
    // ctor
    //
    
    fEmptyData = new EmptyData();
    fTruth = NULL;
}

//______________________________________________________________________________
NoEventGenerator::~NoEventGenerator() {
    //
    // dtor
    //
    
    if ( fEmptyData ) delete fEmptyData;
}

//______________________________________________________________________________
PhysicsData* NoEventGenerator::Get() {
    //
    // get a new event
    //
    
    return fEmptyData;
}

//______________________________________________________________________________
MCTruth* NoEventGenerator::GetTruth() {
    //
    // get pointer to MonteCarlo Truth
    //
    
    if(fTruth == NULL) fTruth = new MCTruth();
    return fTruth;
}
