// ESAF : Euso Simulation and Analysis Framework
// $Id: LidarLightSource.hh,v 1.8 2006/03/20 21:51:35 thea Exp $
// D. De Marco - M. Pallavicini created Jan, 20 2002

#ifndef __LIDARLIGHTSOURCE_HH_
#define __LIDARLIGHTSOURCE_HH_

#include "euso.hh"
#include "LightSource.hh"

class LidarLightSource : public LightSource {
public:
    // ctor
    LidarLightSource();

    // dtor
    virtual ~LidarLightSource();
    
    // generate photons 
    virtual PhotonsInAtmosphere* Get( const PhysicsData* );

    // get ready fo next event
    virtual void Reset() {}  //TOFIX : to be implemented

    virtual Bool_t ClearMemory() {return kTRUE;}
    // release all the mem hold in the buffers

    EsafConfigClass(LightSource,LidarLightSource)
private:

    ClassDef(LidarLightSource,0)
};

#endif  /* __LIDARLIGHTSOURCE_HH_ */

