// ESAF : Euso Simulation and Analysis Framework
// $Id: LightSourceFactory.hh,v 1.8 2004/09/28 12:10:42 thea Exp $
// Anne Stutz created Mar, 23 2004

#ifndef __LIGHTSOURCEFACTORY_HH_
#define __LIGHTSOURCEFACTORY_HH_

#include "euso.hh"
#include "EsafConfigurable.hh"

class FluoCalculator;
class CrkCalculator;

class LightSourceFactory : public EsafConfigurable {
public:
    // dtor
    virtual ~LightSourceFactory();

    // instance 
    static LightSourceFactory *Get();

    // Get Fluorescence Calculator
    FluoCalculator *GetFluoCalculator( const string& name );

    // Get Cerenkov Calculator
    CrkCalculator *GetCrkCalculator( const string& name );

    EsafConfigClass(LightSource,LightSourceFactory);
 
private:
    // ctor
    LightSourceFactory();

    // unique instance of LightSourceFactory
    static LightSourceFactory *fMe;

    ClassDef(LightSourceFactory,0)
};

#endif  /* __LIGHTSOURCEFACTORY_HH_ */

