// ESAF : Euso Simulation and Analysis Framework
// $Id: StandardLightToEuso.hh,v 1.3 2006/03/20 21:51:35 thea Exp $
// Marco Pallavicini created Mar, 13 2002

#ifndef __STANDARDLIGHTTOEUSO_HH_
#define __STANDARDLIGHTTOEUSO_HH_

#include "euso.hh"
#include "LightToEuso.hh"

class PhysicsData;
class PhotonsInAtmosphere;
class PhotonsOnPupil;

class StandardLightToEuso : public LightToEuso {
public:
    // ctor
    StandardLightToEuso();

    // dtor
    virtual ~StandardLightToEuso();
    
    // get photons
    virtual PhotonsOnPupil *Get(const DetectorGeometry*);

    // setup StandardLightToEuso 
    virtual void Configure();
    
    // get MonteCarlo truth
    virtual MCTruth* GetTruth();

    // get physics data of the event
    virtual PhysicsData* GetPhysics() { return 0; }
    
    virtual void ReplaceInputFile(const char*) {}

    virtual Bool_t ClearMemory();

    EsafConfigClass(LightToEuso,StandardLightToEuso)

private:

    void SaveEvent( const PhysicsData* );
    // saves PhysicsData with the proper filler

    ClassDef(StandardLightToEuso,0)
};

#endif  /* __STANDARDLIGHTTOEUSO_HH_ */

