#!/usr/bin/perl

use Getopt::Std;
getopt('f');
$config_file_name = $opt_f;
if ( $config_file_name eq "" ) {
    print "Error. Configuration name not given\n";
    print "Usage: MakeConfig -f name\n";
    exit(0);
}

# list of directories under config
# could be dinamucally built, but it's good enough like this

@dirs = ("Shower","Optics","General","Electronics","LightToEuso");

# get current dir and assumes it is esaf root
# FIXME: check that this is true to be done
chomp($cwd=`pwd`);

# delete temp file
if ( -f "/tmp/.mkcnfg.cfg" ) {
    unlink "/tmp/.mkcnfg.cfg";
} 

# loop on directories and cat all .cfg files into a temporary file
foreach $dir (@dirs) {
    $dd = "$cwd/config/$dir";
    @files = `ls $dd/*.cfg`;
    foreach $fil (@files) {
        chomp($fil);
        `cat $fil >> /tmp/.mkcnfg.cfg`;
    }
}

# cp temporary file to right place
if ( -f "$cwd/config/Standard/$config_file_name" ) {
    print "A standard config with this name already exists\n";
    print "Not overwritten\n";
    exit;
}

`cp /tmp/.mkcnfg.cfg $cwd/config/Standard/$config_file_name`;
`echo $config_file_name | cat >> $cwd/config/Standard/Config.cfg`;

