#!/usr/bin/perl
# Dmitry Naumov

$packname  = $ARGV[0];
$InputList    = $ARGV[1];
$ESAFDOC = $ARGV[2];
$listofclasses =  "$ESAFDOC/ListOfClasses";
$listofpaths   =  "$ESAFDOC/ListOfPaths";

my @classes = ();

&makelist();

sub makelist()
{
    if ($InputList eq "dummy") {
        $linkdef ="include/LinkDef.hh";
    } else {
        $linkdef  ="include/$InputList[0]LinkDef.hh";
        $packname =$InputList;
    }
    open(in,$linkdef);

    my $pwd = `pwd`;
    chomp($pwd);

    while(<in>)
    {
        # collect the entries of LinkDef
        if ( $_ =~ /\#pragma link C\+\+ (class|namespace)[ ]+([^\+\-;]+)/o ) {
            push @classes,$2;
        }
    }
    close(in);

    if ($#classes ne -1 && update_paths($pwd) ) {
        print "Current directory added to ListOfPaths\n";
    } 

    if ( my $n = update_names(@classes) ) {
        print "$n entries added to ListOfClasses.\n";
    }

}

sub update_names() {
    my @names = @_;
    my $nEntries = 0;

    # open fo reading
    open(fileNames,"<$listofclasses");
    for my $entry (<fileNames>) {
        # loop on the names already in ListOfClasses
        $nEntries++;
        chomp($entry);

        for($idx = 0; $idx < @names; ) {
            # loop on the LinkDef classes
            # if the name is already in ListOfClasses, remove it frm the list
            if ( @names[$idx] eq $entry ) {
                splice(@names,$idx,1);
                last;
            }
            $idx++;
        }

    }
    close fileNames;

    # re-open the file in append mode
    open(fileNames,">>$listofclasses");
    # append the new classes
    for(@names) { print fileNames "$_\n"; }
    close fileNames;

    return $#names+1;
}

sub update_paths()
{
    my $pwd = @_[0];

    open(filePaths,"<$listofpaths") ;
    while(<filePaths>)
    {
        chomp;
        if($_ eq $pwd)
        {
            close(filePaths);
            return 0;
        }
    }
    close(filePaths);

    open(filePaths,">>$listofpaths") ;
#    print "$pwd\n";
    print filePaths "$pwd\n";
    close(filePaths);

    return 1;
}

